/*******************************************************************************
 * @author    Patricie Benešová
 * @version   1.00.000
 */
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
public class Trideni
{
   private List<Osoba> seznamOsob = new ArrayList<>();

    public Trideni() {
        seznamOsob.add(new Osoba("Pavel", 30, 183.5));
        seznamOsob.add(new Osoba("Klára", 20, 172.2));
        seznamOsob.add(new Osoba("Jan", 18, 178.6));
        seznamOsob.add(new Osoba("Kateřina", 18, 180.2));
        seznamOsob.add(new Osoba("Tomáš", 24, 184.0));
        seznamOsob.add(new Osoba("Jana", 50, 168.5));
        seznamOsob.add(new Osoba("Rudolf", 73, 184.0));
        seznamOsob.add(new Osoba("Petra", 88, 160.0));
    }

    /**
     * Getter pro získání seznamu osob
     */
    public List<Osoba> getSeznamOsob() {
        return seznamOsob;
    }
    
     public static void main(String[] args) {

        Trideni t = new Trideni();

        t.vypsatPJmena(t.getSeznamOsob());
        t.vypsatMapuDleVeku(t.getSeznamOsob());
        t.vypsatPrumernouVysku(t.getSeznamOsob());
        t.vypsatSpojeni(t.getSeznamOsob());
    }

    /**
     * Metoda vypíše všechny osoby jejichž jména začíná na P
     */
    public void vypsatPJmena(List<Osoba> seznam) {
        System.out.println("Osoby s jménem na P:");
        List<Osoba> seznamP = seznam.stream().filter(p -> p.getJmeno().startsWith("P")).collect(Collectors.toList());
        System.out.println(seznamP);
    }

    /**
     * Metoda vypíše osoby shlukované dle věku
     */
    public void vypsatMapuDleVeku(List<Osoba> seznam) {
        System.out.println("Mapa osob dle věku:");
        Map<Integer, List<Osoba>> mapaVek = seznam.stream().collect(Collectors.groupingBy(p -> p.getVek()));
        mapaVek.forEach((vek, osoba) -> System.out.format("věk %s: %s\n", vek, osoba));
    }

    /**
     * Metoda vypíše půrměrnou výšku osob
     */
    public void vypsatPrumernouVysku(List<Osoba> seznam) {
        System.out.println("Průměrná výška:");
        double prumernaVyska = seznam.stream().collect(Collectors.averagingDouble(p -> p.getVyska()));
        System.out.println(prumernaVyska);
    }

    /**
     * Metoda vypíše větu "Osoby x a y jsou starší 60-ti let" s nahrazením x a y konkrétními jmény osob
     */
    public void vypsatSpojeni(List<Osoba> seznam) {
        System.out.println("Spojování:");
        String veta = seznam.stream().filter(p -> p.getVek() > 60).map(p -> p.getJmeno())
                .collect(Collectors.joining(" a ", "Osoby ", " jsou starší 60-ti let."));
        System.out.println(veta);
    }

}
